<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 4</h1>
    <a>Ejercicio 11</a>

    <script>

        let res;

        class Node {
            constructor(val) {
                this.data = val;
                this.left = null;
                this.right = null;
            }
        }   

        const nCaminos = (root, n, p, suma) => {
     
            if (root != null) {
                if (suma + root.data === n)
                res++;
 
                res += p.get(suma + root.data - n) == null 
                    ? 0 
                    : p.get(suma + root.data - n);
 
                if (!p.has(suma + root.data)) {
                    p.set(suma + root.data, 0);
                }

                p.set(suma + root.data, p.get(suma + root.data) + 1);
 
                nCaminos(root.left, n, p, suma + root.data);
                nCaminos(root.right, n, p, suma + root.data);

                p.set(suma + root.data, p.get(suma + root.data) - 1);
            }
        }

        const imprimirCont  = (root, n) => {

            let p = new Map();

            nCaminos(root, n, p, 0);

            return res;
        }

        res = 0;
        let root = new Node(1);
        root.left = new Node(2);
        root.left.left = new Node(1);
        root.left.right = new Node(2);
        root.right = new Node(-1); 
        root.right.left = new Node(3);
        root.right.left.left = new Node(2);
        root.right.left.right = new Node(5);

        let n = 3;

        console.log(`El numero de nodos con la suma ${n} es: ${imprimirCont(root, n)}`);
        
    </script>
    
</body>
</html>